/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package TelcoEntity;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Collection;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;

/**
 *
 * @author matterbury
 */
@Entity
@Table(name = "ACCOUNT")
@NamedQueries({@NamedQuery(name = "Account.findByAccnum", query = "SELECT a FROM Account a WHERE a.accnum = :accnum"), @NamedQuery(name = "Account.findByDiscount", query = "SELECT a FROM Account a WHERE a.discount = :discount"), @NamedQuery(name = "Account.findByRating", query = "SELECT a FROM Account a WHERE a.rating = :rating"), @NamedQuery(name = "Account.findByBalance", query = "SELECT a FROM Account a WHERE a.balance = :balance")})
public class Account implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Column(name = "ACCNUM", nullable = false)
    private Integer accnum;
    @Column(name = "DISCOUNT")
    private Short discount;
    @Column(name = "RATING")
    private Character rating;
    @Column(name = "BALANCE")
    private BigDecimal balance;
    @OneToMany(mappedBy = "accnum")
    private Collection<Service> serviceCollection;
    @OneToMany(mappedBy = "accnum")
    private Collection<Payment> paymentCollection;
    @JoinColumns({@JoinColumn(name = "CNAME", referencedColumnName = "CNAME"), @JoinColumn(name = "ALINE1", referencedColumnName = "LINE1")})
    @ManyToOne
    private Address address;
    @JoinColumn(name = "CNAME", referencedColumnName = "NAME", insertable=false, updatable=false)
    @ManyToOne
    private Customer cname;

    public Account() {
    }

    public Account(Integer accnum) {
        this.accnum = accnum;
    }

    public Integer getAccnum() {
        return accnum;
    }

    public void setAccnum(Integer accnum) {
        this.accnum = accnum;
    }

    public Short getDiscount() {
        return discount;
    }

    public void setDiscount(Short discount) {
        this.discount = discount;
    }

    public Character getRating() {
        return rating;
    }

    public void setRating(Character rating) {
        this.rating = rating;
    }

    public BigDecimal getBalance() {
        return balance;
    }

    public void setBalance(BigDecimal balance) {
        this.balance = balance;
    }

    public Collection<Service> getServiceCollection() {
        return serviceCollection;
    }

    public void setServiceCollection(Collection<Service> serviceCollection) {
        this.serviceCollection = serviceCollection;
    }

    public Collection<Payment> getPaymentCollection() {
        return paymentCollection;
    }

    public void setPaymentCollection(Collection<Payment> paymentCollection) {
        this.paymentCollection = paymentCollection;
    }

    public Address getAddress() {
        return address;
    }

    public void setAddress(Address address) {
        this.address = address;
    }

    public Customer getCname() {
        return cname;
    }

    public void setCname(Customer cname) {
        this.cname = cname;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (accnum != null ? accnum.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Account)) {
            return false;
        }
        Account other = (Account) object;
        if ((this.accnum == null && other.accnum != null) || (this.accnum != null && !this.accnum.equals(other.accnum))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "TelcoEntity.Account[accnum=" + accnum + "]";
    }

}
