/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package TelcoEntity;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 *
 * @author matterbury
 */
@Entity
@Table(name = "PAYMENT")
@NamedQueries({@NamedQuery(name = "Payment.findByUid", query = "SELECT p FROM Payment p WHERE p.uid = :uid"), @NamedQuery(name = "Payment.findByAmount", query = "SELECT p FROM Payment p WHERE p.amount = :amount"), @NamedQuery(name = "Payment.findByPaidOn", query = "SELECT p FROM Payment p WHERE p.paidOn = :paidOn")})
public class Payment implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "UID", nullable = false)
    private Integer uid;
    @Column(name = "AMOUNT")
    private BigDecimal amount;
    @Column(name = "PAID_ON")
    @Temporal(TemporalType.DATE)
    private Date paidOn;
    @JoinColumn(name = "ACCNUM", referencedColumnName = "ACCNUM")
    @ManyToOne
    private Account accnum;

    public Payment() {
    }

    public Payment(Integer uid) {
        this.uid = uid;
    }

    public Integer getUid() {
        return uid;
    }

    public void setUid(Integer uid) {
        this.uid = uid;
    }

    public BigDecimal getAmount() {
        return amount;
    }

    public void setAmount(BigDecimal amount) {
        this.amount = amount;
    }

    public Date getPaidOn() {
        return paidOn;
    }

    public void setPaidOn(Date paidOn) {
        this.paidOn = paidOn;
    }

    public Account getAccnum() {
        return accnum;
    }

    public void setAccnum(Account accnum) {
        this.accnum = accnum;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (uid != null ? uid.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Payment)) {
            return false;
        }
        Payment other = (Payment) object;
        if ((this.uid == null && other.uid != null) || (this.uid != null && !this.uid.equals(other.uid))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "TelcoEntity.Payment[uid=" + uid + "]";
    }

}
